#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>

public Plugin:myinfo = 
{
	name = "Grenade trails",
	author = "NoTiCE by Kowalski",
	version = "1.0",
};

new Handle:g_hCvar_fg = INVALID_HANDLE;
new Handle:g_hCvar_hg = INVALID_HANDLE;
new Handle:g_hCvar_sg = INVALID_HANDLE;

new Handle:mp_restartgame = INVALID_HANDLE;

new Handle:g_hFlashGrenades = INVALID_HANDLE;
new Handle:g_hHEGrenades = INVALID_HANDLE;
new Handle:g_hSmokeGrenades = INVALID_HANDLE;

public OnPluginStart()
{
	g_hCvar_fg = CreateConVar("sm_fg_enable", "1", "Включить следы от слеповой гранаты?", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	g_hCvar_hg = CreateConVar("sm_hg_enable", "1", "Включить следы от взрывной гранаты?", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	g_hCvar_sg = CreateConVar("sm_sg_enable", "1", "Включить следы от дымовой гранаты?", FCVAR_PLUGIN, true, 0.0, true, 1.0);
	
	AutoExecConfig(true, "grenade_trails");
	
	mp_restartgame = FindConVar("mp_restartgame");
	HookConVarChange(mp_restartgame, ClearAdtArray);
	
	g_hFlashGrenades = CreateArray();
	g_hHEGrenades = CreateArray();
	g_hSmokeGrenades = CreateArray();
	
	HookEvent("flashbang_detonate", Event_FlashbangDetonate);
	HookEvent("hegrenade_detonate", Event_HEGrenadeDetonate);
	HookEvent("round_start", Event_RoundStart);
}

public Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	FullyClearArray(g_hFlashGrenades);
	FullyClearArray(g_hHEGrenades);
	FullyClearArray(g_hSmokeGrenades);
}

public Event_FlashbangDetonate(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(!GetConVarBool(g_hCvar_fg))
		return;
	
	decl Float:fOrigin[3], Float:fOriginFlash[3];
	fOrigin[0] = GetEventFloat(event, "x");
	fOrigin[1] = GetEventFloat(event, "y");
	fOrigin[2] = GetEventFloat(event, "z");
	
	new iSize = GetArraySize(g_hFlashGrenades);
	
	if(iSize > 0)
	{
		new Handle:hGrenade, iGrenade;
		decl String:classname[64];
		for(new i = 0; i < iSize; i++)
		{
			hGrenade = GetArrayCell(g_hFlashGrenades, i);
			iGrenade = GetArrayCell(hGrenade, 0);
			if(IsValidEdict(iGrenade))
			{
				GetEdictClassname(iGrenade, classname, sizeof(classname));
				
				if(StrEqual(classname, "flashbang_projectile", false))
				{
					GetEntPropVector(iGrenade, Prop_Send, "m_vecOrigin", fOriginFlash);
					
					if(fOrigin[0] == fOriginFlash[0] && fOrigin[1] == fOriginFlash[1] && fOrigin[2] == fOriginFlash[2] && (GetArraySize(hGrenade) > 1))
					{
						SDKUnhook(iGrenade, SDKHook_Spawn, Hook_OnSpawnFlashProjectile);
						new particle = GetArrayCell(hGrenade, 1);
						if(IsValidEdict(particle))
						{
							AcceptEntityInput(particle, "TurnOff");
							AcceptEntityInput(particle, "Kill");
						}
						
						CloseHandle(hGrenade);
						RemoveFromArray(g_hFlashGrenades, i);
						break;
					}
				}
			}
		}
	}
}

public Event_HEGrenadeDetonate(Handle:event, const String:name[], bool:dontBroadcast)
{
	if(!GetConVarBool(g_hCvar_hg))
		return;
	
	decl Float:fOrigin[3], Float:fOriginHE[3];
	fOrigin[0] = GetEventFloat(event, "x");
	fOrigin[1] = GetEventFloat(event, "y");
	fOrigin[2] = GetEventFloat(event, "z");
	
	new iSize = GetArraySize(g_hHEGrenades);
	
	if(iSize > 0)
	{
		new Handle:hGrenade, iGrenade;
		decl String:classname[64];
		for(new i = 0; i < iSize; i++)
		{
			hGrenade = GetArrayCell(g_hHEGrenades, i);
			iGrenade = GetArrayCell(hGrenade, 0);
			if(IsValidEdict(iGrenade))
			{
				GetEdictClassname(iGrenade, classname, sizeof(classname));
				
				if(StrEqual(classname, "hegrenade_projectile", false))
				{
					GetEntPropVector(iGrenade, Prop_Send, "m_vecOrigin", fOriginHE);
					
					if(fOrigin[0] == fOriginHE[0] && fOrigin[1] == fOriginHE[1] && fOrigin[2] == fOriginHE[2] && (GetArraySize(hGrenade) > 1))
					{
						SDKUnhook(iGrenade, SDKHook_Spawn, Hook_OnSpawnHEProjectile);
						
						new particle = GetArrayCell(hGrenade, 1);
						if(IsValidEdict(particle))
						{
							AcceptEntityInput(particle, "TurnOff");
							AcceptEntityInput(particle, "Kill");
						}
						
						CloseHandle(hGrenade);
						RemoveFromArray(g_hHEGrenades, i);
						break;
					}
				}
			}
		}
	}
}

public OnEntityCreated(entity, const String:classname[])
{
	if (StrEqual(classname, "flashbang_projectile", false) && GetConVarBool(g_hCvar_fg))
		SDKHook(entity, SDKHook_Spawn, Hook_OnSpawnFlashProjectile);
	
	else if(StrEqual(classname, "hegrenade_projectile", false) && GetConVarBool(g_hCvar_hg))
		SDKHook(entity, SDKHook_Spawn, Hook_OnSpawnHEProjectile);
	
	else if(StrEqual(classname, "smokegrenade_projectile", false) && GetConVarBool(g_hCvar_sg))
		SDKHook(entity, SDKHook_Spawn, Hook_OnSpawnSmokeProjectile);
	
	else if(StrEqual(classname, "env_particlesmokegrenade", false) && GetConVarBool(g_hCvar_sg))
		SDKHook(entity, SDKHook_Spawn, Hook_OnSpawnSmokeParticles);
}

public Hook_OnSpawnFlashProjectile(entity)
{
	if(!GetConVarBool(g_hCvar_fg))
		return;
	
	new particle = CreateEntityByName("env_smokestack");
	if(IsValidEdict(particle))
	{
		decl String:Name[32], Float:fPos[3];
		Format(Name, sizeof(Name), "SmokeParticle_%i", entity);
		GetEntPropVector(entity, PropType:0, "m_vecOrigin", fPos, 0);
		new Float:fAng[3] = 0.0;
		DispatchKeyValueVector(particle, "Origin", fPos);
		DispatchKeyValueVector(particle, "Angles", fAng);
		DispatchKeyValueFloat(particle, "BaseSpread", 3.0);
		DispatchKeyValueFloat(particle, "StartSize", 2.0);
		DispatchKeyValueFloat(particle, "EndSize", 4.0);
		DispatchKeyValueFloat(particle, "Twist", 0.0);
		DispatchKeyValue(particle, "Name", Name);
		DispatchKeyValue(particle, "SmokeMaterial", "particle/smokestack.vmt");
		DispatchKeyValue(particle, "RenderColor", "30 225 255");
		DispatchKeyValue(particle, "SpreadSpeed", "10");
		DispatchKeyValue(particle, "RenderAmt", "200");
		DispatchKeyValue(particle, "JetLength", "13");
		DispatchKeyValue(particle, "RenderMode", "0");
		DispatchKeyValue(particle, "Initial", "0");
		DispatchKeyValue(particle, "Speed", "10");
		DispatchKeyValue(particle, "Rate", "173");
		DispatchSpawn(particle);
		
		SetVariantString("!activator");
		AcceptEntityInput(particle, "SetParent", entity, particle, 0);
		AcceptEntityInput(particle, "TurnOn");
		
		new Handle:hGrenade = CreateArray();
		PushArrayCell(hGrenade, entity);
		PushArrayCell(hGrenade, particle);
		PushArrayCell(g_hFlashGrenades, hGrenade);
	}
	else
		LogError("Failed to create env_smokestack!");
}

public Hook_OnSpawnHEProjectile(entity)
{
	if(!GetConVarBool(g_hCvar_hg))
		return;
	
	new particle = CreateEntityByName("env_smokestack");
	if(IsValidEdict(particle))
	{
		decl String:Name[32], Float:fPos[3];
		Format(Name, sizeof(Name), "SmokeParticle_%i", entity);
		GetEntPropVector(entity, PropType:0, "m_vecOrigin", fPos, 0);
		new Float:fAng[3] = 0.0;
		DispatchKeyValueVector(particle, "Origin", fPos);
		DispatchKeyValueVector(particle, "Angles", fAng);
		DispatchKeyValueFloat(particle, "BaseSpread", 3.0);
		DispatchKeyValueFloat(particle, "StartSize", 2.0);
		DispatchKeyValueFloat(particle, "EndSize", 4.0);
		DispatchKeyValueFloat(particle, "Twist", 0.0);
		DispatchKeyValue(particle, "Name", Name);
		DispatchKeyValue(particle, "SmokeMaterial", "particle/smokestack.vmt");
		DispatchKeyValue(particle, "RenderColor", "255 0 0");
		DispatchKeyValue(particle, "SpreadSpeed", "10");
		DispatchKeyValue(particle, "RenderAmt", "200");
		DispatchKeyValue(particle, "JetLength", "13");
		DispatchKeyValue(particle, "RenderMode", "0");
		DispatchKeyValue(particle, "Initial", "0");
		DispatchKeyValue(particle, "Speed", "10");
		DispatchKeyValue(particle, "Rate", "173");
		DispatchSpawn(particle);
		
		SetVariantString("!activator");
		AcceptEntityInput(particle, "SetParent", entity, particle, 0);
		AcceptEntityInput(particle, "TurnOn");
		
		new Handle:hGrenade = CreateArray();
		PushArrayCell(hGrenade, entity);
		PushArrayCell(hGrenade, particle);
		PushArrayCell(g_hHEGrenades, hGrenade);
	}
	else
		LogError("Failed to create env_smokestack!");
}

public Hook_OnSpawnSmokeProjectile(entity)
{
	if(!GetConVarBool(g_hCvar_sg))
		return;
	
	decl String:name[24];
	GetEntPropString(entity, Prop_Data, "m_iName", name, sizeof(name));
	if (!strcmp(name, "bullet_trail", false))
		return;
	
	new particle = CreateEntityByName("env_smokestack");
	//new particle = CreateEntityByName("env_steam");
	if(IsValidEdict(particle))
	{
		decl String:Name[32], Float:fPos[3];
		Format(Name, sizeof(Name), "SmokeParticle_%i", entity);
		GetEntPropVector(entity, PropType:0, "m_vecOrigin", fPos, 0);
		new Float:fAng[3] = 0.0;
		DispatchKeyValueVector(particle, "Origin", fPos);
		DispatchKeyValueVector(particle, "Angles", fAng);
		DispatchKeyValueFloat(particle, "BaseSpread", 3.0);
		DispatchKeyValueFloat(particle, "StartSize", 2.0);
		DispatchKeyValueFloat(particle, "EndSize", 4.0);
		DispatchKeyValueFloat(particle, "Twist", 0.0);
		DispatchKeyValue(particle, "Name", Name);
		DispatchKeyValue(particle, "SmokeMaterial", "particle/smokestack.vmt");
		DispatchKeyValue(particle, "RenderColor", "0 255 0");
		DispatchKeyValue(particle, "SpreadSpeed", "10");
		DispatchKeyValue(particle, "RenderAmt", "200");
		DispatchKeyValue(particle, "JetLength", "13");
		DispatchKeyValue(particle, "RenderMode", "0");
		DispatchKeyValue(particle, "Initial", "0");
		DispatchKeyValue(particle, "Speed", "10");
		DispatchKeyValue(particle, "Rate", "173");
		DispatchSpawn(particle);
		
		SetVariantString("!activator");
		AcceptEntityInput(particle, "SetParent", entity, particle, 0);
		AcceptEntityInput(particle, "TurnOn");
		
		new Handle:hGrenade = CreateArray();
		PushArrayCell(hGrenade, entity);
		PushArrayCell(hGrenade, particle);
		PushArrayCell(g_hSmokeGrenades, hGrenade);
	}
	else
		LogError("Failed to create env_smokestack!");
}

public Hook_OnSpawnSmokeParticles(entity)
{
	if(!GetConVarBool(g_hCvar_sg))
		return;
	
	SDKUnhook(entity, SDKHook_Spawn, Hook_OnSpawnSmokeParticles);
	
	decl Float:fOrigin[3], Float:fOriginSmoke[3];
	GetEntPropVector(entity, Prop_Send, "m_vecOrigin", fOrigin);
	
	new iSize = GetArraySize(g_hSmokeGrenades);
	
	if(iSize > 0)
	{
		new Handle:hGrenade, iGrenade;
		decl String:classname[64];
		for(new i = 0; i < iSize; i++)
		{
			hGrenade = GetArrayCell(g_hSmokeGrenades, i);
			iGrenade = GetArrayCell(hGrenade, 0);
			
			if(IsValidEdict(iGrenade))
			{
				GetEdictClassname(iGrenade, classname, sizeof(classname));
				if(StrEqual(classname, "smokegrenade_projectile", false))
				{
					GetEntPropVector(iGrenade, Prop_Send, "m_vecOrigin", fOriginSmoke);
					
					if(fOrigin[0] == fOriginSmoke[0] && fOrigin[1] == fOriginSmoke[1] && fOrigin[2] == fOriginSmoke[2] && (GetArraySize(hGrenade) > 1))
					{
						SDKUnhook(iGrenade, SDKHook_Spawn, Hook_OnSpawnSmokeProjectile);
						
						new particle = GetArrayCell(hGrenade, 1);
						if(IsValidEdict(particle))
						{
							AcceptEntityInput(particle, "TurnOff");
							AcceptEntityInput(particle, "Kill");
						}
						
						CloseHandle(hGrenade);
						RemoveFromArray(g_hSmokeGrenades, i);
						break;
					}
				}
			}
		}
	}
}

public ClearAdtArray(Handle:convar, const String:oldValue[], const String:newValue[])
{
	FullyClearArray(g_hFlashGrenades);
	FullyClearArray(g_hHEGrenades);
	FullyClearArray(g_hSmokeGrenades);
}

FullyClearArray(Handle:hArray)
{
	new iSize = GetArraySize(hArray);
	if(iSize > 0)
	{
		new Handle:hTempArray;
		for(new i = 0; i < iSize; i++)
		{
			hTempArray = GetArrayCell(hArray, i);
			CloseHandle(hTempArray);
		}
		
		ClearArray(hArray);
	}
}